/*  qapbb.f -- translated by f2c (version 20020621),
     and hand rewritten to Plan 9's C dialect by
     Peter A. Cejchan <cej@gli.cas.cz | pac7@post.cz> 
     Tue Apr 11 11:32:03 MET 2006 

*/

//includes
#include <u.h>
#include <libc.h>
#include <bio.h>

//defines
#define FALSE_ 0
#define TRUE_ 1

/* Table of constant values */

static int c__33 = 33;
static int c__1 = 1;
static int c__3 = 3;
static int c__9 = 9;

//prototypes
void in_open(int argc, char **argv);
void in_close(Biobuf *bin);
int  _readdim(int *dim, Biobuf *bin);
int _read(int v[], int rows, int cols, Biobuf *bin);

//declarations
Biobuf *bin;

int 
qap_(int *n, int *a, int *b, int *unendl,
	 int *loesg, int *olwert, int *c__, int *umspei, 
	int *zul, int *u, int *v, int *dd, int *partpe, 
	int *y, int *lab, int *z1, int *h1, int *meng, 
	int *phiofm, int *menge, int *veksum, int *vekqu, 
	int *alter, int *aspei, int *bspei, int *cspei, 
	int *bool, int *bool1, int *hl1, int *ndim)
{
    /* System generated locals */
    int a_dim1, a_offset, b_dim1, b_offset, c_dim1, c_offset, zul_dim1, 
	    zul_offset, i__1, i__2, i__3;

    /* Local variables */
    static int i__, j, k, t, i1, i2, j1, j2, t1, t2, ca, am, bm, ra, rb, 
	    jj, kk, iz, jz, ca1, nm2, ccc, lbd, raa, rbb, bmj, min__, nmk, 
	    ize, min1, min2, ikap;
    extern int lsap_(int *, int *, int *, 
	    int *, int *, int *, int *, int *, int *, 
	    int *, int *, int *);
    static int ihalt, jhalt, zpart, izaehl, jzaehl, alterk;
    extern int wegspe_(int *, int *, int *, 
	    int *, int *, int *, int *, int *, int *, 
	    int *, int *, int *, int *, int *, int *),
	     altkos_(int *, int *, int *, int *, int *, 
	    int *, int *);
    static int weiter;
    extern int progno_(int *, int *, int *, 
	    int *, int *, int *, int *, int *, int *, 
	    int *);
    static int zstern;



/*** ***************************************************************
    *                                                              
    *          PROCEDURE FOR SOLVING QUADRATIC ASSIGNMENT          
    *                          PROBLEMS                            
    *                                                              
*** ***************************************************************
    *                                                              
    *  1. CALL:                                                    
    *     CALL QAP (N,A,B,UNENDL,LOESG,OLWERT,C,UMSPEI,ZUL,U,V,DD, 
    *               PARTPE,Y,LAB,Z1,H1,MENG,PHIOFM,MENGE,VEKSUM,   
    *               VEKQU,ALTER,ASPEI,BSPEI,CSPEI,BOOL,BOOL1,HL1)  
    *                                                              
    *  2. COMPUTER CODE:                                           
    *     FORTRAN IV                                               
    *                                                              
    *  3. METHOD:                                                  
    *     PERTURBATION METHOD FOR THE OPTIMAL SOLUTION OF          
    *     QUADRATIC ASSIGNMENT PROBLEMS                            
    *                                                              
    *  4. PARAMETERS:                                              
    *     INPUT:                                                   
    *        N        DIMENSION OF THE PROBLEM                     
    *        NDIM     DIMENSION OF CALLING PROGRAM 
    *        A(I,J)   DISTANCE MATRIX (INTEGER)  I,J=1,...,N       
    *        B(I,J)   CONNECTION MATRIX (INTEGER)  I,J=1,...,N     
    *        UNENDL   LARGE MACHINE NUMBER (INTEGER)               
    *     OUTPUT:                                                  
    *        LOESG(I) OPTIMAL ASSIGNMENT (INTEGER)                 
    *                  I --> LOESG(I)  I=1,...,N                   
    *        OLWERT   OPTIMAL OBJECTIVE FUNCTION VALUE (INTEGER)   
    *     INTEGER ARRAYS OF DIMENSION (N,N)                        
    *        C(I,J), ZUL(I,J)                                      
    *     INTEGER ARRAYS OF DIMENSION N                            
    *        U(I), V(I), DD(I), PARTPE(I), Y(I), LAB(I), Z1(I),    
    *        H1(I)                                                 
    *     INTEGER ARRAY OF DIMENSION N*N                           
    *        UMSPEI(I)                                             
    *     INTEGER ARRAYS OF DIMENSION N-2                          
    *        MENG(I), PHIOFM(I), MENGE(I), VEKSUM(I), VEKQU(I),    
    *        ALTER(I)                                              
    *     INTEGER ARRAYS OF DIMENSION N*(N+1)*(2*N-2)/6            
    *        ASPEI(I), BSPEI(I)                                    
    *     INTEGER ARRAY OF DIMENSION (N*(N+1)*(2*N+1)/6)-1         
    *        CSPEI(I)                                              
    *     LOGICAL ARRAYS OF DIMENSION N                            
    *        BOOL(I), BOOL1(I), HL1(I)                             
    *                                                              
    *  5. EXTERNAL SUBROUTINES:                                    
    *     SUBROUTINE ALTKOS                                        
    *     SUBROUTINE WEGSPE                                        
    *     SUBROUTINE PROGNO                                        
    *     SUBROUTINE LSAP                                          
    *     SUBROUTINE SSORT                                         
    *                                                              
    *  6. COMMENT:                                                 
    *     THE ELEMENTS OF THE MATRICES A AND B HAVE TO BE          
    *     NONNEGATIVE INTEGERS. THEY ARE CHANGED DURING THE        
    *     PROCEDURE.                                               
    *                                                              
    *  7. AUTHORS:                                                 
    *     T. BOENNIGER                                             
    *     R.E. BURKARD                                             
    *     K.-H. STRATMANN                                          
    *                                                              
*** ***************************************************************/


    /* Parameter adjustments */
    --loesg;
    --umspei;
    --u;
    --v;
    --dd;
    --partpe;
    --y;
    --lab;
    --z1;
    --h1;
    --meng;
    --phiofm;
    --menge;
    --veksum;
    --vekqu;
    --alter;
    --aspei;
    --bspei;
    --cspei;
    --bool;
    --bool1;
    --hl1;
    zul_dim1 = *ndim;
    zul_offset = 1 + zul_dim1 * 1;
    zul -= zul_offset;
    c_dim1 = *ndim;
    c_offset = 1 + c_dim1 * 1;
    c__ -= c_offset;
    b_dim1 = *ndim;
    b_offset = 1 + b_dim1 * 1;
    b -= b_offset;
    a_dim1 = *ndim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;

    /* Function Body */
    k = 0;
/* ***      OLWERT = UNENDL (here a user defined value can come in) */
    nm2 = *n - 2;
    i2 = *n + 1;
    j = 0;
    j1 = 0;
    i__1 = nm2;
    for (i__ = 1; i__ <= i__1; ++i__) {
	nmk = i2 - i__;
	j2 = nmk * nmk;
	j = j + j2 - nmk;
	veksum[i__] = j;
	j1 += j2;
/* L5035: */
	vekqu[i__] = j1;
    }

/* *** 1. REDUCTION: C(I,J) = A(I,I) * B(J,J) */

    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	bool[i__] = FALSE_;
	bool1[i__] = FALSE_;
	zstern = a[i__ + i__ * a_dim1];
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
	    zul[i__ + j * zul_dim1] = -1;
/* consider linear term c */
/* L5010: */
	    c__[i__ + j * c_dim1] = zstern * b[j + j * b_dim1] + c__[i__ + j *
		     c_dim1];
	}
    }
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
	a[j + j * a_dim1] = *unendl;
/* L5030: */
	b[j + j * b_dim1] = *unendl;
    }
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* *** REDUCTION OF MATRICES A AND B */

    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	ra = a[i__ + a_dim1];
	rb = b[i__ + b_dim1];
	i__1 = *n;
	for (j = 2; j <= i__1; ++j) {
	    raa = a[i__ + j * a_dim1];
	    rbb = b[i__ + j * b_dim1];
	    if (raa < ra) {
		ra = raa;
	    }
	    if (rbb < rb) {
		rb = rbb;
	    }
/* L5101: */
	}
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    a[i__ + j * a_dim1] -= ra;
/* L5102: */
	    b[i__ + j * b_dim1] -= rb;
	}
	u[i__] = ra;
/* L5103: */
	v[i__] = rb;
    }
/* << */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* *** DETERMINATION OF THE MATRIX C */
/*     ROWWISE REDUCTION OF MATRICES A AND B */

    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	ca1 = u[i__];
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    bmj = v[j];
	    bm = (*n - 1) * bmj;
	    i__3 = *n;
	    for (kk = 1; kk <= i__3; ++kk) {
		if (kk == j) {
		    goto L5104;
		}
		bm += b[j + kk * b_dim1];
L5104:
		;
	    }
	    ca = ca1 * bm;
	    am = 0;
	    i__3 = *n;
	    for (kk = 1; kk <= i__3; ++kk) {
		if (kk == i__) {
		    goto L5105;
		}
		am += a[i__ + kk * a_dim1];
L5105:
		;
	    }
/* L5106: */
	    c__[i__ + j * c_dim1] = ca + bmj * am + c__[i__ + j * c_dim1];
	}
    }

/* *** COLUMNWISE REDUCTION OF MATRICES A AND B */

    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ra = a[i__ * a_dim1 + 1];
	rb = b[i__ * b_dim1 + 1];
	i__2 = *n;
	for (j = 2; j <= i__2; ++j) {
	    raa = a[j + i__ * a_dim1];
	    rbb = b[j + i__ * b_dim1];
	    if (raa < ra) {
		ra = raa;
	    }
	    if (rbb < rb) {
		rb = rbb;
	    }
/* L5107: */
	}
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
	    a[j + i__ * a_dim1] -= ra;
/* L5108: */
	    b[j + i__ * b_dim1] -= rb;
	}
	u[i__] = ra;
/* L5109: */
	v[i__] = rb;
    }
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	a[i__ + i__ * a_dim1] = 0;
	b[i__ + i__ * b_dim1] = 0;
	ca1 = u[i__];
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
	    bmj = v[j];
	    bm = (*n - 1) * bmj;
	    i__3 = *n;
	    for (kk = 1; kk <= i__3; ++kk) {
		if (kk == j) {
		    goto L5110;
		}
		bm += b[kk + j * b_dim1];
L5110:
		;
	    }
	    ca = ca1 * bm;
	    am = 0;
	    i__3 = *n;
	    for (kk = 1; kk <= i__3; ++kk) {
		if (kk == i__) {
		    goto L5111;
		}
		am += a[kk + i__ * a_dim1];
L5111:
		;
	    }
	    ccc = c__[i__ + j * c_dim1] + ca + bmj * am;
	    c__[i__ + j * c_dim1] = ccc;
/* L5112: */
	}
    }
    zpart = 0;
    nmk = *n;
    weiter = TRUE_;

/*
       IMPROVEMENT OF THE BOUNDS C(I,J) BY ADDING MINIMAL SCALAR 
       PRODUCTS (GILMORE BOUNDS). THE SUBROUTINES WEGSPE AND PROGNO 
       COMPUTE THESE MINIMAL SCALAR PRODUCTS. 
*/

    wegspe_(n, &k, &nmk, &izaehl, &jzaehl, &a[a_offset], &b[b_offset], &
	    veksum[1], &u[1], &bool[1], &bool1[1], &aspei[1], &bspei[1], &h1[
	    1], ndim);
    progno_(n, &k, &nmk, &umspei[1], &veksum[1], &vekqu[1], &weiter, &aspei[1]
	    , &bspei[1], &cspei[1]);
    weiter = FALSE_;
L5210:
    iz = 0;
    i2 = 0;
    j2 = 0;
    ikap = 0;
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (bool[i__]) {
	    goto L5120;
	}
	jj = iz * nmk;
	++iz;
	jz = 0;
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    if (bool1[j]) {
		goto L5125;
	    }
	    ++jz;
	    ++jj;
	    if (zul[i__ + j * zul_dim1] < 0) {
		goto L5145;
	    }
	    umspei[jj] = *unendl;
	    ++ikap;
	    if ((i__3 = ikap - 2) < 0) {
		goto L5375;
	    } else if (i__3 == 0) {
		goto L5380;
	    } else {
		goto L5125;
	    }
L5375:
	    ihalt = iz;
	    jhalt = jz;
	    goto L5125;
L5380:
	    if (iz == ihalt) {
		i2 = iz;
	    }
	    if (jz == jhalt) {
		j2 = jz;
	    }
	    goto L5125;
L5145:
	    umspei[jj] = c__[i__ + j * c_dim1] + umspei[jj];
L5125:
	    ;
	}
L5120:
	;
    }
/* *** COMPUTATION OF A BOUND BY SOLVING LSAP WITH COSTMATRIX UMSPEI */

L5180:
    lsap_(&nmk, unendl, &umspei[1], &zstern, &y[1], &z1[1], &lab[1], &dd[1], &
	    u[1], &v[1], &h1[1], &hl1[1]);
    jj = 0;
    i__2 = nmk;
    for (i__ = 1; i__ <= i__2; ++i__) {
	i__1 = nmk;
	for (j = 1; j <= i__1; ++j) {
	    ++jj;
	    umspei[jj] = umspei[jj] - u[i__] - v[j];
/* L5181: */
	}
/* L5182: */
    }

/* *** ZPART IS THE FIXED FRACTION OF THE OBJECTIVE FUNCTION VALUE */
/*     IMPLIED BY THE PRESENT PARTIAL PERMUTATION. */
/*     THE PRESENT BOUND IS ZPART+ZSTERN. */

    if (zpart + zstern >= *olwert) {
	goto L5250;
    }
    if (lbd < zpart + zstern) {
	lbd = zpart + zstern;
/*                print 998, lbd */
    }
/* L998: */
    if (weiter) {
	goto L5220;
    }
L5135:
    if ((i__2 = ikap - 1) < 0) {
	goto L5400;
    } else if (i__2 == 0) {
	goto L5410;
    } else {
	goto L5420;
    }

/* *** COMPUTATION OF THE ALTERNATIVE COSTS */

L5400:
    altkos_(&nmk, &umspei[1], &z1[1], unendl, &izaehl, &jzaehl, &alterk);
    goto L5490;

/* *** COMPUTATION OF THE NEXT SINGLE ASSIGNMENT IN A FIXED ROW 
       OR COLUMN */

L5410:
    min__ = *unendl;
    j1 = z1[ihalt];
    jj = (ihalt - 1) * nmk;
    i__2 = nmk;
    for (j = 1; j <= i__2; ++j) {
	++jj;
	t = umspei[jj];
	if (min__ <= t || j == j1) {
	    goto L5430;
	}
	min__ = t;
L5430:
	;
    }
    min1 = min__;
    min__ = *unendl;
    jj = j1;
    i__2 = nmk;
    for (i__ = 1; i__ <= i__2; ++i__) {
	t = umspei[jj];
	jj += nmk;
	if (min__ <= t || i__ == ihalt) {
	    goto L5510;
	}
	min__ = t;
L5510:
	;
    }
    min1 += min__;
    min__ = *unendl;
    jj = jhalt;
    i__2 = nmk;
    for (i__ = 1; i__ <= i__2; ++i__) {
	t = umspei[jj];
	jj += nmk;
	if (t >= min__ || jhalt == z1[i__]) {
	    goto L5440;
	}
	min__ = t;
L5440:
	;
    }
    min2 = min__;
    i__2 = nmk;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (z1[i__] == jhalt) {
	    goto L5540;
	}
/* L5530: */
    }
L5540:
    i1 = i__;
    jj = (i1 - 1) * nmk;
    min__ = *unendl;
    i__2 = nmk;
    for (j = 1; j <= i__2; ++j) {
	++jj;
	t = umspei[jj];
	if (t >= min__ || j == jhalt) {
	    goto L5520;
	}
	min__ = t;
L5520:
	;
    }
    if (min__ + min2 < min1) {
	goto L5450;
    }
    izaehl = i1;
    jzaehl = jhalt;
    alterk = min__ + min2;
    goto L5490;
L5450:
    izaehl = ihalt;
    jzaehl = j1;
    alterk = min1;
    goto L5490;
/* << */
/* *** COMPUTATION OF THE NEXT SINGLE ASSIGNMENT IN THE PREVIOUSLY 
     FIXED ROW (RESP. PREVIOUSLY FIXED COLUMN) */

L5420:
    if (i2 == 0) {
	goto L5480;
    }
    izaehl = i2;
    jzaehl = z1[izaehl];
    goto L5370;
L5480:
    jzaehl = j2;
    i__2 = nmk;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (z1[i__] == jzaehl) {
	    goto L5485;
	}
/* L5470: */
    }
L5485:
    izaehl = i__;
L5370:
    min__ = *unendl;
    jj = (izaehl - 1) * nmk;
    i__2 = nmk;
    for (i__ = 1; i__ <= i__2; ++i__) {
	++jj;
	t = umspei[jj];
	if (t >= min__ || i__ == jzaehl) {
	    goto L5350;
	}
	min__ = t;
L5350:
	;
    }
    alterk = min__;
    min__ = *unendl;
    jj = jzaehl;
    i__2 = nmk;
    for (j = 1; j <= i__2; ++j) {
	t = umspei[jj];
	jj += nmk;
	if (t >= min__ || j == izaehl) {
	    goto L5360;
	}
	min__ = t;
L5360:
	;
    }
    alterk += min__;
L5490:
    iz = 0;
    alter[k + 1] = alterk + zstern;
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (bool[i__]) {
	    goto L5155;
	}
	++iz;
	if (izaehl == iz) {
	    goto L5165;
	}
L5155:
	;
    }
L5165:
    izaehl = i__;
    iz = 0;
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
	if (bool1[j]) {
	    goto L5175;
	}
	++iz;
	if (jzaehl == iz) {
	    goto L5185;
	}
L5175:
	;
    }
L5185:
    jzaehl = j;
    zul[izaehl + jzaehl * zul_dim1] = k;
    weiter = TRUE_;
    bool[izaehl] = TRUE_;
    bool1[jzaehl] = TRUE_;
    nmk = *n - k - 1;
/* *** COMPUTATION OF THE COST MATRIX CORRESPONDING TO THE NEW PARTIAL 
    PERMUTATION */

    wegspe_(n, &k, &nmk, &izaehl, &jzaehl, &a[a_offset], &b[b_offset], &
	    veksum[1], &u[1], &bool[1], &bool1[1], &aspei[1], &bspei[1], &h1[
	    1], ndim);
    progno_(n, &k, &nmk, &umspei[1], &veksum[1], &vekqu[1], &weiter, &aspei[1]
	    , &bspei[1], &cspei[1]);
    iz = 0;
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (bool[i__]) {
	    goto L5130;
	}
	t1 = a[i__ + izaehl * a_dim1];
	t2 = a[izaehl + i__ * a_dim1];
	jz = iz;
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    if (bool1[j]) {
		goto L5140;
	    }
	    ++jz;
	    umspei[jz] = c__[i__ + j * c_dim1] + t1 * b[j + jzaehl * b_dim1] 
		    + t2 * b[jzaehl + j * b_dim1] + umspei[jz];
L5140:
	    ;
	}
	iz += nmk;
L5130:
	;
    }
    zpart += c__[izaehl + jzaehl * c_dim1];
    goto L5180;
/* *** THE BOUND FOR THE NEW PARTIAL PERMUTATION IS NOT LESS THAN A 
     PREVIOUSLY FOUND OBJECTIVE FUNCTION VALUE. 
     - BACKTRACKING - */

L5250:
    if (! weiter) {
	goto L5255;
    }
    weiter = FALSE_;
    ++k;
    goto L5230;

/* *** EXIT: THE SOLUTION TREE IS COMPLETELY FATHOMED. */

L5255:
    if (k == 0) {
	goto L5600;
    }
    izaehl = menge[k];
    jzaehl = phiofm[k];
L5220:
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (bool[i__]) {
	    goto L5150;
	}
	t1 = a[izaehl + i__ * a_dim1];
	t2 = a[i__ + izaehl * a_dim1];
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    if (bool1[j]) {
		goto L5160;
	    }
	    t = t1 * b[jzaehl + j * b_dim1] + t2 * b[j + jzaehl * b_dim1];
	    if (! weiter) {
		t = -t;
	    }
	    c__[i__ + j * c_dim1] += t;
L5160:
	    ;
	}
L5150:
	;
    }
    if (! weiter) {
	goto L5230;
    }
    partpe[izaehl] = jzaehl;
    ++k;
    menge[k] = izaehl;
    phiofm[k] = jzaehl;
    if (k == *n - 2) {
	goto L5270;
    }
    ikap = 0;
    goto L5135;

/* *** CANCELLATION OF THE LAST SINGLE ASSIGNMENT */

L5230:
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (bool[i__]) {
	    goto L5260;
	}
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    if (! bool1[j] && zul[i__ + j * zul_dim1] == k) {
		zul[i__ + j * zul_dim1] = -1;
	    }
/* L5240: */
	}
L5260:
	;
    }
    zpart -= c__[izaehl + jzaehl * c_dim1];
    bool[izaehl] = FALSE_;
    bool1[jzaehl] = FALSE_;
    --k;
    nmk = *n - k;
    if (alter[k + 1] + zpart >= *olwert) {
	goto L5255;
    }
    progno_(n, &k, &nmk, &umspei[1], &veksum[1], &vekqu[1], &weiter, &aspei[1]
	    , &bspei[1], &cspei[1]);
    goto L5210;

/* *** COMPUTATION OF THE OBJECTIVE FUNCTION VALUES FOR THE REMAINING 
     TWO COMPLETE PERMUTATIONS */

L5270:
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (bool[i__]) {
	    goto L5290;
	}
	iz = i__;
	goto L5285;
L5290:
	;
    }
L5285:
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (bool1[i__]) {
	    goto L5280;
	}
	j = i__;
	goto L5295;
L5280:
	;
    }
L5295:
    bool[iz] = TRUE_;
    bool1[j] = TRUE_;
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (bool[i__]) {
	    goto L5310;
	}
	i1 = i__;
	goto L5305;
L5310:
	;
    }
L5305:
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (bool1[i__]) {
	    goto L5300;
	}
	j1 = i__;
	goto L5315;
L5300:
	;
    }
L5315:
    weiter = FALSE_;
    ize = 0;
L5330:
    zstern = c__[iz + j * c_dim1] + c__[i1 + j1 * c_dim1] + a[iz + i1 * 
	    a_dim1] * b[j + j1 * b_dim1] + a[i1 + iz * a_dim1] * b[j1 + j * 
	    b_dim1];
    bool[iz] = FALSE_;
    bool1[j] = FALSE_;
    if (zstern + zpart >= *olwert) {
	goto L5340;
    }
    *olwert = zstern + zpart;
/*      print 999,olwert */
    lbd = 0;
/* L999: */
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	if (bool[i__]) {
	    loesg[i__] = partpe[i__];
	}
/* L5320: */
    }
    i__2 = nm2;
    for (i__ = 1; i__ <= i__2; ++i__) {
/* L5335: */
	meng[i__] = menge[i__];
    }
    loesg[iz] = j;
    loesg[i1] = j1;
L5340:
    if (ize != 0) {
	goto L5255;
    }
    ize = iz;
    iz = i1;
    i1 = ize;
    goto L5330;
L5600:
    return 0;
} // qap_ 




int 
altkos_(int *n, int *umspei, int *z1, 
	int *unendl, int *izaehl, int *jzaehl, int *alterk)
{
    /* System generated locals */
    int i__1, i__2;

    /* Local variables */
    static int a, i__, j, i1, j1, jj, min__, min1;

/* *** DETERMINATION OF ALTERNATIVE COSTS AND THE RESULTING SINGLE  ASSIGNMENT. */

    /* Parameter adjustments */
    --z1;
    --umspei;

    /* Function Body */
    *alterk = -1;
    jj = 0;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	j = z1[i__];
	j1 = j - *n;
	min__ = *unendl;
	i__2 = *n;
	for (i1 = 1; i1 <= i__2; ++i1) {
	    j1 += *n;
	    if (i1 == i__) {
		goto L4120;
	    }
	    a = umspei[j1];
	    if (a < min__) {
		min__ = a;
	    }
L4120:
	    ;
	}
	min1 = min__;
	min__ = *unendl;
	i__2 = *n;
	for (i1 = 1; i1 <= i__2; ++i1) {
	    ++jj;
	    if (i1 == j) {
		goto L4130;
	    }
	    a = umspei[jj];
	    if (a < min__) {
		min__ = a;
	    }
L4130:
	    ;
	}
	min__ += min1;
	if (min__ <= *alterk) {
	    goto L4110;
	}
	*izaehl = i__;
	*jzaehl = j;
	*alterk = min__;
L4110:
	;
    }
    return 0;
} // altkos_

int 
wegspe_(int *n, int *k, int *nmk, int *
	izaehl, int *jzaehl, int *a, int *b, int *veksum, 
	int *vekt, int *bool, int *bool1, int *aspei, int 
	*bspei, int *h1, int *ndim)
{
    /* System generated locals */
    int a_dim1, a_offset, b_dim1, b_offset, i__1, i__2;

    /* Local variables */
    static int i__, j, t, j1, j2, iz;
    static int logi;
    static int nmkj, nmkm2, nsum1;
    extern /* Subroutine */ int ssort_(int *, int *, int *);

/* *** ORDERING OF THE ELEMENTS IN THE ROWS OF THE MATRIX A 
    DECREASINGLY AND IN MATRIX B INCREASINGLY. THE RESULTING 
    MATRICES ARE ROWWISE STORED ON THE VECTORS ASPEI AND BSPEI. */

    /* Parameter adjustments */
    --veksum;
    --vekt;
    --bool;
    --bool1;
    --aspei;
    --bspei;
    --h1;
    b_dim1 = *ndim;
    b_offset = 1 + b_dim1 * 1;
    b -= b_offset;
    a_dim1 = *ndim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;

    /* Function Body */
    nmkm2 = *nmk - 1;
    if (*nmk != *n) {
	goto L2900;
    }
    j1 = 1;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	iz = 0;
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
	    if (j == i__) {
		goto L2820;
	    }
	    ++iz;
	    vekt[iz] = a[i__ + j * a_dim1];
L2820:
	    ;
	}
	ssort_(&vekt[1], &h1[1], &nmkm2);
	i__2 = nmkm2;
	for (j = 1; j <= i__2; ++j) {
	    nmkj = *nmk - j;
	    aspei[j1] = vekt[nmkj];
/* L2810: */
	    ++j1;
	}
    }
    j1 = 1;
    i__2 = *n;
    for (i__ = 1; i__ <= i__2; ++i__) {
	iz = 0;
	i__1 = *n;
	for (j = 1; j <= i__1; ++j) {
	    if (j == i__) {
		goto L2850;
	    }
	    ++iz;
	    vekt[iz] = b[i__ + j * b_dim1];
L2850:
	    ;
	}
	ssort_(&vekt[1], &h1[1], &nmkm2);
	i__1 = nmkm2;
	for (j = 1; j <= i__1; ++j) {
	    bspei[j1] = vekt[j];
/* L2840: */
	    ++j1;
	}
    }
    return 0;
L2900:
    nsum1 = veksum[*k + 1];
    j1 = nsum1;
    j2 = nsum1 - (*nmk + 1) * *nmk;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (bool[i__]) {
	    goto L2930;
	}
	t = a[i__ + *izaehl * a_dim1];
	logi = TRUE_;
	i__2 = *nmk;
	for (j = 1; j <= i__2; ++j) {
	    ++j2;
	    if (aspei[j2] == t && logi) {
		goto L2980;
	    }
	    ++j1;
	    aspei[j1] = aspei[j2];
	    goto L2920;
L2980:
	    logi = FALSE_;
L2920:
	    ;
	}
	goto L2910;
L2930:
	if (i__ == *izaehl) {
	    j2 += *nmk;
	}
L2910:
	;
    }
    j1 = nsum1;
    j2 = nsum1 - (*nmk + 1) * *nmk;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (bool1[i__]) {
	    goto L2960;
	}
	t = b[i__ + *jzaehl * b_dim1];
	logi = TRUE_;
	i__2 = *nmk;
	for (j = 1; j <= i__2; ++j) {
	    ++j2;
	    if (bspei[j2] == t && logi) {
		goto L2970;
	    }
	    ++j1;
	    bspei[j1] = bspei[j2];
	    goto L2950;
L2970:
	    logi = FALSE_;
L2950:
	    ;
	}
	goto L2940;
L2960:
	if (i__ == *jzaehl) {
	    j2 += *nmk;
	}
L2940:
	;
    }
    return 0;
} /* wegspe_ */

/* Subroutine */ int progno_(int *n, int *k, int *nmk, int *
	umspei, int *veksum, int *vekqu, int *weiter, int *
	aspei, int *bspei, int *cspei)
{
    /* System generated locals */
    int i__1, i__2, i__3;

    /* Local variables */
    static int i__, j, t, j1, j2, j3, ju, iz, j2iz, j3iz, nmkm1, nsum2;

/* *** COMPUTATION OF THE FINAL COST MATRIX UMSPEI FOR THE LINEAR 
     SUBPROBLEM LSAP ON THE K-TH STAGE OF THE DECISION TREE */

    /* Parameter adjustments */
    --cspei;
    --bspei;
    --aspei;
    --vekqu;
    --veksum;
    --umspei;

    /* Function Body */
    ju = 0;
    if (*nmk != *n) {
	goto L3600;
    }
    nsum2 = 0;
    j1 = 0;
    if (*weiter) {
	goto L3680;
    }
    goto L3690;
L3600:
    if (*weiter) {
	goto L3630;
    }
    j1 = vekqu[*k];
L3690:
    i__1 = *nmk;
    for (i__ = 1; i__ <= i__1; ++i__) {
	i__2 = *nmk;
	for (j = 1; j <= i__2; ++j) {
	    ++j1;
	    ++ju;
/* L3640: */
	    umspei[ju] = cspei[j1];
	}
    }
    return 0;
L3630:
    nsum2 = veksum[*k + 1];
    j1 = vekqu[*k + 1];
L3680:
    j2 = nsum2;
    nmkm1 = *nmk - 1;
    i__2 = *nmk;
    for (i__ = 1; i__ <= i__2; ++i__) {
	j3 = nsum2;
	i__1 = *nmk;
	for (j = 1; j <= i__1; ++j) {
	    ++j1;
	    ++ju;
	    t = 0;
	    i__3 = nmkm1;
	    for (iz = 1; iz <= i__3; ++iz) {
		j2iz = j2 + iz;
		j3iz = j3 + iz;
/* L3670: */
		t += aspei[j2iz] * bspei[j3iz];
	    }
	    j3 += nmkm1;
	    cspei[j1] = t;
/* L3660: */
	    umspei[ju] = t;
	}
/* L3650: */
	j2 += nmkm1;
    }
    return 0;
} // progno_




int 
lsap_(int *n, int *sup, int *c__, int *
	z__, int *zeile, int *spalte, int *dminus, int *dplus,
	 int *ys, int *yt, int *vor, int *label)
{
    /* System generated locals */
    int i__1, i__2;

    /* Local variables */
    static int d__, i__, j, u, w, cc, ik, jo, is, ui, vj, us, ws, ind, 
	    isj, vgl, usi, wsi, index;

/*** ***************************************************************
    *                                                              
    *                                                              
    *            LINEAR SUM ASSIGNMENT PROBLEM                     
    *                                                              
*** ***************************************************************
    *  1.  CALL:                                                   
    *      CALL LSAP(N,SUP,C,Z,ZEILE,SPALTE,DMINUS,DPLUS,YS,YT,VOR,
    *                LABEL)                                        
    *                                                              
    *  2.  COMPUTER CODE:                                          
    *      FORTRAN IV                                              
    *                                                              
    *  3.  METHOD:                                                 
    *      SHORTEST AUGMENTING PATH METHOD                         
    *                                                              
    *  4.  PARAMETERS:                                             
    *      INPUT:                                                  
    *         N     DIMENSION OF THE COST MATRIX  C                
    *         C(I)  COST MATRIX (I=1,...N*N) , ROWWISE STORED      
    *         SUP   LARGE MACHINE NUMBER                           
    *      OUTPUT:                                                 
    *         SPALTE(I)   OPTIMAL ASSIGNMENT (I=1,...,N)           
    *         Z           OPTIMAL VALUE                            
    *         YS(I)     OPTIMAL DUAL (ROW) VARIABLES    (I=1,...,N)
    *         YT(I)     OPTIMAL DUAL (COLUMN) VARIABLES (I=1,...,N)
    *      INTEGER ARRAYS OF LENGHTS N:                            
    *         ZEILE(I),DMINUS(I),DPLUS(I),YS(I),YT(I),VOR(1)       
    *      LOGICAL ARRAY OF LENGTH N:                              
    *         LABEL(I)                                             
    *                                                              
    *  5.  EXTERNAL SUBROUTINES:                                   
    *      NONE                                                    
    *                                                              
    *  6.  AUTHOR:                                                 
    *      U.DERIGS                                                
    *                                                              
*** ***************************************************************/

/*     CONSTRUCTION OF AN INITIAL (PARTIAL) ASSIGNMENT */

    /* Parameter adjustments */
    --label;
    --vor;
    --yt;
    --ys;
    --dplus;
    --dminus;
    --spalte;
    --zeile;
    --c__;

    /* Function Body */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	zeile[i__] = 0;
	spalte[i__] = 0;
	vor[i__] = 0;
	ys[i__] = 0;
/* L50: */
	yt[i__] = 0;
    }
    ik = 0;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
	    ++ik;
	    cc = c__[ik];
	    if (j == 1) {
		goto L4;
	    }
	    if (cc - ui >= 0) {
		goto L3;
	    }
L4:
	    ui = cc;
	    jo = j;
L3:
	    ;
	}
	ys[i__] = ui;
	if (zeile[jo] != 0) {
	    goto L2;
	}
	zeile[jo] = i__;
	spalte[i__] = jo;
L2:
	;
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	yt[j] = 0;
	if (zeile[j] == 0) {
	    yt[j] = *sup;
	}
/* L5: */
    }
    ik = 0;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ui = ys[i__];
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
	    ++ik;
	    vj = yt[j];
	    if (vj <= 0) {
		goto L7;
	    }
	    cc = c__[ik] - ui;
	    if (cc >= vj) {
		goto L7;
	    }
	    yt[j] = cc;
	    vor[j] = i__;
L7:
	    ;
	}
/* L6: */
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	i__ = vor[j];
	if (i__ == 0) {
	    goto L8;
	}
	if (spalte[i__] != 0) {
	    goto L8;
	}
	spalte[i__] = j;
	zeile[j] = i__;
L8:
	;
    }
/* << */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (spalte[i__] != 0) {
	    goto L9;
	}
	ui = ys[i__];
	ik = (i__ - 1) * *n;
	i__2 = *n;
	for (j = 1; j <= i__2; ++j) {
	    ++ik;
	    if (zeile[j] != 0) {
		goto L10;
	    }
	    cc = c__[ik];
	    if (cc - ui - yt[j] > 0) {
		goto L10;
	    }
	    spalte[i__] = j;
	    zeile[j] = i__;
	    goto L9;
L10:
	    ;
	}
L9:
	;
    }
/* *** CONSTRUCTION OF THE OPTIMAL ASSIGNMENT */

    i__1 = *n;
    for (u = 1; u <= i__1; ++u) {
	if (spalte[u] > 0) {
	    goto L1000;
	}
/* *** SHORTEST PATH COMPUTATION */

	us = (u - 1) * *n;
	i__2 = *n;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    vor[i__] = u;
	    label[i__] = FALSE_;
	    dplus[i__] = *sup;
	    usi = us + i__;
/* L100: */
	    dminus[i__] = c__[usi] - ys[u] - yt[i__];
	}
	dplus[u] = 0;
L105:
	d__ = *sup;
	i__2 = *n;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    if (label[i__]) {
		goto L110;
	    }
	    if (dminus[i__] >= d__) {
		goto L110;
	    }
	    d__ = dminus[i__];
	    index = i__;
L110:
	    ;
	}
	if (zeile[index] <= 0) {
	    goto L400;
	}
	label[index] = TRUE_;
	w = zeile[index];
	ws = (w - 1) * *n;
	dplus[w] = d__;
	i__2 = *n;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    if (label[i__]) {
		goto L130;
	    }
	    wsi = ws + i__;
	    vgl = d__ + c__[wsi] - ys[w] - yt[i__];
	    if (dminus[i__] <= vgl) {
		goto L130;
	    }
	    dminus[i__] = vgl;
	    vor[i__] = w;
L130:
	    ;
	}
	goto L105;
/* *** AUGMENTATION */

L400:
	w = vor[index];
	zeile[index] = w;
	ind = spalte[w];
	spalte[w] = index;
	if (w == u) {
	    goto L500;
	}
	index = ind;
	goto L400;
/* *** TRANSFORMATION */

L500:
	i__2 = *n;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    if (dplus[i__] == *sup) {
		goto L505;
	    }
	    ys[i__] = ys[i__] + d__ - dplus[i__];
L505:
	    if (dminus[i__] >= d__) {
		goto L510;
	    }
	    yt[i__] = yt[i__] + dminus[i__] - d__;
L510:
	    ;
	}
L1000:
	;
    }

/* *** COMPUTATION OF THE OPTIMAL VALUE */

    *z__ = 0;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	is = (i__ - 1) * *n;
	j = spalte[i__];
	isj = is + j;
	*z__ += c__[isj];
/* L2000: */
    }
    return 0;
} // lsap_

int 
ssort_(int *a, int *b, int *l)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int f, i__, j, s, t, n2, ah, bh, is, js, ls;

/*** ***************************************************************
    *                                                              
    *                       SORT                    
    *                                                              
*** ***************************************************************
    *                                                              
    *  1. CALL:                                                    
    *     CALL SSORT (A,B,N)                                       
    *                                                              
    *  2. COMPUTER CODE:                                           
    *     FORTRAN IV                                               
    *                                                              
    *  3. METHOD:                                                  
    *     SORTING OF THE VECTOR A(I) IN INCREASING ORDER BY THE    
    *     SHELL-ALGORITHM.                                         
    *                                                              
    *  4. PARAMETERS:                                              
    *     INPUT:                                                   
    *        N        DIMENSION OF THE VECTOR                      
    *        A(I)     VECTOR TO SORT (INTEGER)  I=1,...,N          
    *        B(I)     = I    (INTEGER)  I=1,...,N                  
    *     OUTPUT:                                                  
    *        A(I)     THE SORTED VECTOR                            
    *        B(I)     PERMUTATION VECTOR OF THE SORTED VECTOR      
    *                                                              
    *  5. EXTERNAL SUBROUTINES:                                    
    *     NONE                                                     
    *                                                              
*** ***************************************************************/

    /* Parameter adjustments */
    --b;
    --a;

    /* Function Body */
    f = 1;
    if (*l <= f) {
	return 0;
    }
    n2 = (*l - f + 1) / 2;
    s = 1023;
    for (t = 1; t <= 10; ++t) {
	if (s > n2) {
	    goto L90;
	}
	ls = *l - s;
	i__1 = ls;
	for (i__ = f; i__ <= i__1; ++i__) {
	    is = i__ + s;
	    ah = a[is];
	    bh = b[is];
	    j = i__;
	    js = is;
L5:
	    if (ah >= a[j]) {
		goto L10;
	    }
	    a[js] = a[j];
	    b[js] = b[j];
	    js = j;
	    j -= s;
	    if (j >= f) {
		goto L5;
	    }
L10:
	    a[js] = ah;
	    b[js] = bh;
/* L20: */
	}
L90:
	s /= 2;
/* L100: */
    }
    return 0;
} // ssort_ 

void
in_open(int argc, char **argv)
//opens input file
{
	char *infile="/fd/0";
	if(argc < 2) {
		infile="/fd/0";
	}

		if(argc == 2) {

		infile=argv[1];
	}
	if ((bin = Bopen(infile, OREAD)) == 0) {
		exits("open");
	}
}

void
in_close(Biobuf *bin)
//closes input file
{
	Bterm(bin);
}

int 
_readdim(int *dim, Biobuf *bin)
// reads #rows (columns) for a square matrix
{
	char *buf, *av[256], first;
	int n;

	n=0;
	while(n==0){
		if((buf = Brdstr(bin, '\n', 1)) == nil) return 0;			// nothing to read
		first=buf[0];
		n=tokenize(buf, av, 2);
		if(n!=0){
			// skip comment lines
			if((first=='#') || (first=='>')){
				n=0;
			}
		}
		else{
		// skip whitespace lines
		}
	}	// ends up with n > 0
	*dim=atoi(av[0]);
	return 1;
}

int
_read(int v[], int rows, int cols, Biobuf *bin)
// CAUTION!! 
// reads in a whitespace and newline separated matrix into a VECTOR, index starting from 1, not 0
{

	char *buf, *av[256];
	int i, j, n,pos=0;
	for(i=1; i<=cols; i++){
		if((buf = Brdstr(bin, '\n', 1)) != nil){	
			// skip comment lines
			while((buf[0]=='#') || (buf[0]=='>')){
				if((buf = Brdstr(bin, '\n', 1)) == nil) return 0;	// read another line
			}	
			n=tokenize(buf, av, cols);
			// skip whitespace lines
			while(n==0){
				if((buf = Brdstr(bin, '\n', 1)) == nil) return 0;	// read another line
				n=tokenize(buf, av, cols);
			}
	
			for(j=0; j<rows; j++)
				v[pos++]=atoi(av[i]);
			free(buf);
		}
		else return 0;
	}
	return 1;
}

/* Main program */ 
void
main(int argc, char **argv)
{

    /* System generated locals */


    /* Local variables */
    static int a[1089]	/* was [33][33] */, b[1089]	/* was [33][
	    33] */, c__[1089]	/* was [33][33] */, i__, n, u[33], v[33], y[
	    33], h1[33], z1[33], dd[33], i__1,  i;
    static int hl1[33];
    static int lab[33];
    extern int qap_(int *, int *, int *, int 
	    *, int *, int *, int *, int *, int *, int 
	    *, int *, int *, int *, int *, int *, int 
	    *, int *, int *, int *, int *, int *, int 
	    *, int *, int *, int *, int *, int *, int 
	    *, int *, int *);
    static int zul[1089]	/* was [33][33] */, meng[31];
    static int bool[33], bool1[33];
    static int menge[31], aspei[11968], bspei[11968], cspei[12528];
    extern /* Subroutine */ int ilese_(int *, int *, int *, 
	    int *, int *);
    static int alter[31], loesg[33], vekqu[31], phiofm[31], unendl, 
	    partpe[33], umspei[1089], veksum[31], olwert;


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* auslegung fuer ndim = 33 */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
	unendl = 1000000000;
	in_open(argc, argv);
	_readdim(&n, bin);
	if(n>= c__33) exits("dimension too big");
	_read(a, n, n, bin);
	_read(b, n, n, bin);
//	_read(c__, n, n, bin);
	for(i__=1; i__<=n*n; i__++) c__[i] = 1;
	in_close(bin);
	olwert = 0;		//read in as parameter !!!
	if (olwert == 0) 
		olwert = unendl;
   
	qap_(&n, a, b, &unendl, loesg, &olwert, c__, umspei, zul, u, v, dd, 
	    partpe, y, lab, z1, h1, meng, phiofm, menge, veksum, vekqu, alter,
	     aspei, bspei, cspei, bool, bool1, hl1, &c__33);
	i__1 = n;
	print("Exact solution: ");
	for (i__ = 1; i__ <= i__1; ++i__) {
	/* L200: */
		print("%d ", loesg[i__ - 1]);
	}
	print("\nObjective function value: %d\n", olwert);
	exits(0);
} // main 
//eof
